<?php

namespace wcf\system\event\listener;
use wcf\system\event\listener\IParameterizedEventListener;
use wcf\util;
use wcf\system\WCF;


/** Extends Ebay, Amazon, PlayAsia Links by Affiliate Parameters
 *
 * @author      PCSG (Jan)
 * @copyright   2001-2009 WoltLab GmbH, 2014-2015 Oliver Schlöbe
 * @license		GNU Lesser General Public License <http://opensource.org/licenses/lgpl-license.php>
 * @package		com.woltlab.wcf
 * @subpackage	system.event.listener
 * @category	Community Framework
 */
class MyelistingLinkReplacerBeforeParse implements IParameterizedEventListener
{
    /**
     * @see \wcf\system\event\listener\IParameterizedEventListener::execute()
     */
    public function execute($eventObj, $className, $eventName, array &$parameters)
    {
        // If no content or no [url]-Tags in post then skip
        if(!$eventObj->message || \wcf\data\bbcode\BBCodeCache::getInstance()->getBBCodeByTag('url') === null){
            return;
        }

        $eventObj->message = str_replace("[URL","[url",$eventObj->message);  //old [URL]-Tags in new [url]-Tags
//        $eventObj->message = $this->replaceString($eventObj->message);

    }


    /**
     * replace ebay links with article info
     *
     * @param string $str message to parse
     * @return string
     */
    private function replaceString($str) {
        $publisherID = '5574790812';
        $campaignID = '5337728413'; //5337197015
        $customerID = 'NXForum';

        $programIDs = array (
            'at' => '5221-53469-19255-0',
            'ch' => '5222-53480-19255-0',
            'com' => '711-53200-19255-0',
            'de' => '707-53477-19255-0'
        );

        /**
         * Now do the magic!
         */
        if ($publisherID != '' && $campaignID != '') {
            if (strstr($str, "cgi.ebay.")) {

                // [url='<URL>']<LinkTitel>[/url] - Tag
                $strarr = explode("[url='", $str);
                for ($i = 0; $i < count($strarr); $i++) {
                    preg_match("/^http:\/\/cgi\.ebay\.(at|ch|com|de)\//i", $strarr [$i], $matches);

                    if (count($matches)) {
                        $restlink = preg_replace("/^http:\/\/cgi\.ebay\.(at|ch|com|de)\//i", '', $strarr [$i]);
                        $affili = "http://rover.ebay.com/rover/1/" . $programIDs [$matches [1]] . "/1?ff3=4&pub=" . urlencode($publisherID) . "&toolid=10001&campid=" . urlencode($campaignID) . "&customid=" . urlencode($customerID) . "&mpre=http://cgi.ebay." . urlencode($matches [1]) . "/";
                        $strarr [$i] = $affili . $restlink;
                    }
                }
                $str = implode("[url='", $strarr);


                // [url]<URL>[/url] - Tag
                $strarr = explode("[url]", $str);
                for ($i = 0; $i < count($strarr); $i++) {
                    preg_match("/^http:\/\/cgi\.ebay\.(at|ch|com|de)\//i", $strarr [$i], $matches);

                    if (count($matches)) {
                        $restlink = preg_replace("/^http:\/\/cgi\.ebay\.(at|ch|com|de)\//i", '', $strarr [$i]);
                        $affili = "http://rover.ebay.com/rover/1/" . $programIDs [$matches [1]] . "/1?ff3=4&pub=" . urlencode($publisherID) . "&toolid=10001&campid=" . urlencode($campaignID) . "&customid=" . urlencode($customerID) . "&mpre=http://cgi.ebay." . urlencode($matches [1]) . "/";
                        $strarr [$i] = $affili . $restlink;
                    }
                }
                $str = implode("[url]", $strarr);
            }


            if (strstr($str, "shop.ebay.")) {
                // [url='<URL>']<LinkTitel>[/url] - Tag
                $strarr = explode("[url='", $str);
                for ($i = 0; $i < count($strarr); $i++) {
                    preg_match("/^http:\/\/shop\.ebay\.(at|ch|com|de)\//i", $strarr [$i], $matches);

                    if (count($matches)) {
                        $restlink = preg_replace("/^http:\/\/shop\.ebay\.(at|ch|com|de)\//i", '', $strarr [$i]);
                        $affili = "http://rover.ebay.com/rover/1/" . $programIDs [$matches [1]] . "/1?ff3=4&pub=" . urlencode($publisherID) . "&toolid=10001&campid=" . urlencode($campaignID) . "&customid=" . urlencode($customerID) . "&mpre=http://shop.ebay." . urlencode($matches [1]) . "/";
                        $strarr [$i] = $affili . $restlink;
                    }
                }
                $str = implode("[url='", $strarr);



                // [url]<URL>[/url] - Tag
                $strarr = explode("[url]", $str);
                for ($i = 0; $i < count($strarr); $i++) {
                    preg_match("/^http:\/\/shop\.ebay\.(at|ch|com|de)\//i", $strarr [$i], $matches);

                    if (count($matches)) {
                        $restlink = preg_replace("/^http:\/\/shop\.ebay\.(at|ch|com|de)\//i", '', $strarr [$i]);
                        $affili = "http://rover.ebay.com/rover/1/" . $programIDs [$matches [1]] . "/1?ff3=4&pub=" . urlencode($publisherID) . "&toolid=10001&campid=" . urlencode($campaignID) . "&customid=" . urlencode($customerID) . "&mpre=http://shop.ebay." . urlencode($matches [1]) . "/";
                        $strarr [$i] = $affili . $restlink;
                    }
                }
                $str = implode("[url]", $strarr);
            }


            if (strstr($str, "www.ebay.")) {
                // [url='<URL>']<LinkTitel>[/url] - Tag
                $strarr = explode("[url='", $str);
                for ($i = 0; $i < count($strarr); $i++) {
                    preg_match("/^http:\/\/www\.ebay\.(at|ch|com|de)\//i", $strarr [$i], $matches);

                    if (count($matches)) {
                        $restlink = preg_replace("/^http:\/\/www\.ebay\.(at|ch|com|de)\//i", '', $strarr [$i]);
                        $affili = "http://rover.ebay.com/rover/1/" . $programIDs [$matches [1]] . "/1?ff3=4&pub=" . urlencode($publisherID) . "&toolid=10001&campid=" . urlencode($campaignID) . "&customid=" . urlencode($customerID) . "&mpre=http://www.ebay." . urlencode($matches [1]) . "/";
                        $strarr [$i] = $affili . $restlink;
                    }
                }
                $str = implode("[url='", $strarr);



                // [url]<URL>[/url] - Tag
                $strarr = explode("[url]", $str);
                for ($i = 0; $i < count($strarr); $i++) {
                    preg_match("/^http:\/\/www\.ebay\.(at|ch|com|de)\//i", $strarr [$i], $matches);

                    if (count($matches)) {
                        $restlink = preg_replace("/^http:\/\/www\.ebay\.(at|ch|com|de)\//i", '', $strarr [$i]);
                        $affili = "http://rover.ebay.com/rover/1/" . $programIDs [$matches [1]] . "/1?ff3=4&pub=" . urlencode($publisherID) . "&toolid=10001&campid=" . urlencode($campaignID) . "&customid=" . urlencode($customerID) . "&mpre=http://www.ebay." . urlencode($matches [1]) . "/";
                        $strarr [$i] = $affili . $restlink;
                    }
                }
                $str = implode("[url]", $strarr);
            }
        }

        return $str;
    }


}